/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

void whoiscalling::my_ok()
{
import sys
# exit here - nothing to be done
sys.exit()
}


void whoiscalling::myinit()
{
import sys
import time
import os
reload (sys)
sys.setdefaultencoding('utf8')
global once
global progname
progname = 'whoiscalling'
if ( once == None ):
	import os
	import re
	import sys

	once = 1
	self.tabWidget2.setCurrentPage(0)

	# read all the calls accumulated in the callsdb.lst file and display them in the table
	indx = 0
	act_path = os.getcwd()
	try:
		db_filename = act_path + "/callsdb.lst"
		db_file = file(db_filename, 'r')
		db = db_file.readline()
		while db:
			# split the read line into an array
			tmp = re.compile("[.|.]")
			array = tmp.split(db)
			# remove leading and trailing blanks
			array[0] = array[0].strip()
			array[1] = array[1].strip()
			array[2] = array[2].strip()
			array[3] = array[3].strip()
			array[4] = array[4].strip()
			array[5] = array[5].strip()
			# the table has one empty lines at the beginning; if that's not enough we need more lines
			if ( indx >= self.calltable.numRows()):
				self.calltable.insertRows(int(self.calltable.numRows()),1)
			# and now fill the table in the form
			self.calltable.setText(indx,0,array[0])
			self.calltable.setText(indx,1,array[1])
			self.calltable.setText(indx,2,array[2])
			self.calltable.setText(indx,3,array[3])
			self.calltable.setText(indx,4,array[4])
			self.calltable.setText(indx,5,array[5])
			indx = indx + 1
			db = db_file.readline()
		db_file.close()
		self.calltable.setCurrentCell(int(self.calltable.numRows()) - 1,0)
	except:
		if ( os.access(db_filename, os.F_OK) == False ):
			print progname, self.__tr(": callsdb file does not exist.")
		elif ( os.access(db_filename, os.R_OK) == False ):
			print progname, self.__tr(": callsdb file is not readable.")
		else:
			print progname, self.__tr(": error in myinit() function while accessing callsdb.lst file.")
	# adjust the width of the columns of the table
	self.calltable.adjustColumn(0)
	self.calltable.adjustColumn(1)
	self.calltable.adjustColumn(2)
	self.calltable.adjustColumn(3)
	self.calltable.adjustColumn(4)
	self.calltable.adjustColumn(5)



	# and handle tab 1
	indx = 0
	act_path = os.getcwd()
	try:
		db_filename = act_path + "/callerdb.txt"
		db_file = file(db_filename, 'r')
		db = db_file.readline()
		while db:
			# split the read line into an array
			tmp = re.compile("[.|.]")
			array = tmp.split(db)
			# remove leading and trailing blanks
			array[0] = array[0].strip()
			array[1] = array[1].strip()
			array[2] = array[2].strip()
			imagesource1 = str(array[2]) + "." + str(array[3])
			imagesource1 = imagesource1.replace("\n","")
			# the table has one empty lines at the beginning; if that's not enough we need more lines
			if ( indx >= self.table1.numRows()):
				self.table1.insertRows(int(self.table1.numRows()),1)
			# and now fill the table in the form
			self.table1.setText(indx,0,array[0])
			self.table1.setText(indx,1,array[1])
			self.table1.setText(indx,2,imagesource1)
			indx = indx + 1
			db = db_file.readline()
		db_file.close()
	except:
		if ( os.access(db_filename, os.F_OK) == False ):
			print progname, self.__tr(": callerdb file does not exist.")
		elif ( os.access(db_filename, os.R_OK) == False ):
			print progname, self.__tr(": callerdb file is not readable.")
		else:
			print progname, self.__tr(": error in myinit() function while accessing callerdb.txt file.")

	# adjust the width of the columns of the table
	self.table1.adjustColumn(0)
	self.table1.adjustColumn(1)
	self.table1.adjustColumn(2)
once = 1
}


void whoiscalling::myreload()
{
import sys
import time
import os
import re
reload (sys)
sys.setdefaultencoding('utf8')
global progname

# first clear the table (that's slow and needs a lot of resources)
for i in range(self.calltable.numRows(), 0, -1):
	self.calltable.removeRow(i)
# read all the calls accumulated in the callsdb.lst file and display them in the table
indx = 0
act_path = os.getcwd()
try:
	db_filename = act_path + "/callsdb.lst"
	db_file = file(db_filename, 'r')
	db = db_file.readline()
	while db:
		# split the read line into an array
		tmp = re.compile("[.|.]")
		array = tmp.split(db)
		# remove leading and trailing blanks
		array[0] = array[0].strip()
		array[1] = array[1].strip()
		array[2] = array[2].strip()
		array[3] = array[3].strip()
		array[4] = array[4].strip()
		array[5] = array[5].strip()
		# the table has one empty lines at the beginning; if that's not enough we need more lines
		if ( indx >= self.calltable.numRows()):
			self.calltable.insertRows(int(self.calltable.numRows()),1)
		# and now fill the table in the form
		self.calltable.setText(indx,0,array[0])
		self.calltable.setText(indx,1,array[1])
		self.calltable.setText(indx,2,array[2])
		self.calltable.setText(indx,3,array[3])
		self.calltable.setText(indx,4,array[4])
		self.calltable.setText(indx,5,array[5])
		indx = indx + 1
		db = db_file.readline()
	db_file.close()
	self.calltable.setCurrentCell(int(self.calltable.numRows()) - 1,0)
except:
	if ( os.access(db_filename, os.F_OK) == False ):
		print progname, self.__tr(": callsdb file does not exist.")
	elif ( os.access(db_filename, os.R_OK) == False ):
		print progname, self.__tr(": callsdb file is not readable.")
	else:
		print progname, self.__tr(": error in myreload() function.")

}


void whoiscalling::myNewCall()
{
	global progname
	import sys
	reload (sys)
	sys.setdefaultencoding('utf8')
	import os
	import re

	# fill the according fields
	self.callernumber.setProperty("value", QVariant(str(self.calltable.text(self.calltable.currentRow(), 3))))
	self.callednumber.setProperty("value", QVariant(str(self.calltable.text(self.calltable.currentRow(), 2))))
#	self.callcity.setText(str(self.calltable.text(self.calltable.currentRow(), 4)))
	c_city = unicode(str(self.calltable.text(self.calltable.currentRow(), 4)), 'utf-8')
	self.callcity.setText(c_city)
	self.si.setText(str(self.calltable.text(self.calltable.currentRow(), 5)))
	self.calldate.setText(str(self.calltable.text(self.calltable.currentRow(), 0)))
	self.calltime.setText(str(self.calltable.text(self.calltable.currentRow(), 1)))

	# now search for caller name and picture
	try:
		hit = False
		act_path = os.getcwd()
		db_filename = act_path + "/callerdb.txt"
		db_file = file(db_filename, 'r')
		db = db_file.readline()
		while db:
			# split the record into an array for easier access
			tmp = re.compile("[.|.]")
			array = tmp.split(db)
			array[0] = array[0].strip()
			array[2] = array[2].strip()
			# the callernumber is identical with the one in the db?
			if ( array[0] == str(self.calltable.text(self.calltable.currentRow(),3) ) ):
				hit = True
				called = str(self.calltable.text(self.calltable.currentRow(),2) )
				glob_caller = str(array[0])
				glob_caller = glob_caller.strip()
				mycallername = str(array[1]).strip()
				self.callername.setText(mycallername)
				# and finally get the image filename and the image itself
				imagesource1 = str(array[2]) + "." + str(array[3])
				imagesource1 = imagesource1.replace("\n","")
				callerpic = QImage (imagesource1)
				scaled = QPixmap (callerpic.scale ( 150.0, 150.0, QImage.ScaleMode(1) ))
				self.pixmapLabel1.setPixmap(scaled)
			db = db_file.readline()
		db_file.close()
		# in case it's a new number
		if ( hit == False ):
				self.callername.setText(self.__tr("unknown number/caller"))
				imagesource1 = act_path + "/Caller/unknown.jpg"
				self.pixmapLabel1.setPixmap( QPixmap (imagesource1) )
	except:
		if ( os.access(db_filename, os.F_OK) == False ):
			print progname, self.__tr(": callerdb file does not exist.")
		elif ( os.access(db_filename, os.R_OK) == False ):
			print progname, self.__tr(": callerdb file is not readable.")
		else:
			print progname, self.__tr(": error in myNewCall(0 function.")

}


void whoiscalling::myselectCaller()
{
	global progname
	import re

	imagesource = self.table1.text(self.table1.currentRow(), 2)
	imagesource = imagesource.replace("\n","")
	callerpic = QImage (imagesource)
	scaled = QPixmap (callerpic.scale ( 150.0, 150.0, QImage.ScaleMode(1) ))
	self.pixmapLabel2.setPixmap(scaled)

}



void whoiscalling::myNewRecord()
{
import os
# simply add one new row into the displayed table; user can fill it but doesn't need to
# the field for the image is pre-filled; user can override this
self.table1.insertRows(int(self.table1.numRows()),1)
self.table1.setText(int(self.table1.numRows()) - 1, 2, str(os.getcwd()) + str("/Caller/noimage.jpg"))
self.table1.setCurrentCell(int(self.table1.numRows()) - 1,0)
}

void whoiscalling::mypicfilechanger()
{
#print self.kURLRequester.url(), 'is the selected file'
self.table1.setText(int(self.table1.numRows()) - 1, 2, str(self.kURLRequester.url()))
}



void whoiscalling::myDeleteRecord()
{
global progname
# do not delete if the user says no
if ( QMessageBox.question( self, self.__tr("Delete Record - WhoIsCalling"), self.__tr("Really delete the selected record?"), QMessageBox.Yes, QMessageBox.No) == 0 ):
	self.table1.removeRow(self.table1.currentRow())
	# do it this way till a way is found how to use the best slot/connection pair = the best event
	import os
	act_path = os.getcwd()
	try:
		db_filename = act_path + "/callerdb.txt"
		db_file = file(db_filename, 'w')
		i = 0
		for i in range(0, self.table1.numRows()):
			wr_strg = str(self.table1.text(i, 0 )) + ' | ' + str(self.table1.text(i, 1 )) + ' | ' + str(self.table1.text(i, 2 )) + ' | ' + str(self.table1.text(i, 3 )) + '\n'
			db_file.write(wr_strg)
		db_file.close()
	except:
		if ( os.access(db_filename, os.F_OK) == False ):
			print progname, self.__tr(": callerdb file does not exist.")
		elif ( os.access(db_filename, os.W_OK) == False ):
			print progname, self.__tr(": callerdb file is not writeable.")
		else:
			print progname, self.__tr(": error in myDeleteRecord() function.")
		QMessageBox.information( self, "Who Is Calling", self.__tr("Error in access the callerdb database file"), QMessageBox.Ok)
}


void whoiscalling::updateCallerDB()
{
global progname
import os
import sys
reload (sys)
sys.setdefaultencoding('utf8')
act_path = os.getcwd()
try:
	db_filename = act_path + "/callerdb.txt"
	db_file = file(db_filename, 'w')
	i = 0
	for i in range(0, self.table1.numRows()):
		wr_strg = str(self.table1.text(i, 0 )) + ' | ' + str(self.table1.text(i, 1 )) + ' | ' + str(self.table1.text(i, 2 )) + '\n'
		db_file.write(wr_strg)
	db_file.close()
except:
	if ( os.access(db_filename, os.F_OK) == False ):
		print progname, self.__tr(": callerdb file does not exist.")
	elif ( os.access(db_filename, os.W_OK) == False ):
		print progname, self.__tr(": callerdb file is not writeable.")
	else:
		print progname, self.__tr(": error in updateCallerDB() function.")
	QMessageBox.information( self, "Who Is Calling", self.__tr("Error in access the callerdb database file"), QMessageBox.Ok)
}


void whoiscalling::mywhatIsSIButton()
{
QMessageBox.information( self, "Who Is Calling", self.__tr("What is SI?\n\nSI means 'Service Indicator' and this gives you the following information:\n\n1.\tSpeech\n2.\tRestricted digital information\n3.\tunrestricted digital information\n4.\tVideo\n7.\tHDLC or X.75\n"), QMessageBox.Ok)
}


# and here some extra nonsense

void whoiscalling::my_aboutKDE()
{
# show the standard About KDE dialog window
from kdecore import KAboutData
aboutdata = KAboutData("Who Is Calling", "whoiscalling", "0.2", "Who is calling", KAboutData.License_GPL, "Copyright (c) 2006 Klaus-J. Luksch")
dlg = KAboutKDE(self, "aboutkde", 1)
dlg.show()
}


void whoiscalling::my_aboutApp()
{
# show the application info window
from kdecore import KAboutData
import os
import sys
act_path = os.getcwd()
more_info = "Initial developer and maintainer\n\n\nWho is calling - Listing your calls over ISDN and your callers\nAll released under the GPL License  -  Copyright (c) 2006\nRunning on " + sys.platform + "; Python version " + sys.version + "\n\n\n"
mylogo = QPixmap(act_path + "/icon.png")
mydialog = KAboutDialog(self)
mydialog.setLogo(mylogo)
mydialog.setCaption("Who is calling)")
mydialog.setVersion("Version: 0.2")
mydialog.setAuthor("Author: Klaus-J. Luksch", "cyberclaus@gmx.net", "http://luksch.homelinux.org", more_info)
mydialog.adjust()
mydialog.show()
}


void whoiscalling::my_aboutPython()
{
# retrieve the Python version and show a simple messagebox
import sys
QMessageBox.information( self, "Python", "\nInstalled Version\t" + sys.version + "\n\n\n", QMessageBox.Ok )
}

